NODE(1)

NAME
node - Server-side JavaScript runtime

SYNOPSIS
node [options] [v8 options] [script.js | -e "script"] [--] [arguments]
node debug [script.js | -e "script" | <host>:<port>] ...
node [--v8-options] Execute without arguments to start the REPL.

DESCRIPTION
Node.js is a set of libraries for JavaScript which allows it to be used outside of the browser. It is primarily focused on creating simple, easy to build network clients and servers.

OPTIONS

-v, --version
    Print node's version.

-h, --help
    Print node command line options. The output of this option is less detailed than this document.

-e, --eval "script"
    Evaluate the following argument as JavaScript.

-p, --print "script"
    Identical to -e but prints the result.

-c, --check
    Syntax check the script without executing.

-i, --interactive
    Open the REPL even if stdin does not appear to be a terminal.

-r, --require module
    Preload the specified module at startup. Follows `require()`'s module resolution rules. module may be either a path to a file, or a node module name.

--no-deprecation
    Silence deprecation warnings.

--trace-deprecation
    Print stack traces for deprecations.

--throw-deprecation
    Throw errors for deprecations.

--no-warnings
    Silence all process warnings (including deprecations).

--trace-warnings
    Print stack traces for process warnings (including deprecations).

--redirect-warnings=file
    Write process warnings to the given file instead of printing to stderr.

--trace-sync-io
    Print a stack trace whenever synchronous I/O is detected after the first turn of the event loop.

--zero-fill-buffers
    Automatically zero-fills all newly allocated Buffer and SlowBuffer instances.

--preserve-symlinks
    Instructs the module loader to preserve symbolic links when resolving and caching modules.

--track-heap-objects
    Track heap object allocations for heap snapshots.

--prof-process
    Process v8 profiler output generated using the v8 option --prof

--v8-options
    Print v8 command line options. Note: v8 options allow words to be separated by both dashes (-) or underscores (_). For example, --stack-trace-limit is equivalent to --stack_trace_limit

--v8-pool-size=num
    Set v8's thread pool size which will be used to allocate background jobs. If set to 0 then v8 will choose an appropriate size of the thread pool based on the number of online processors. If the value provided is larger than v8's max then the largest value will be chosen.

--tls-cipher-list=list
    Specify an alternative default TLS cipher list. (Requires Node.js to be built with crypto support. (Default))

--enable-fips
    Enable FIPS-compliant crypto at startup. (Requires Node.js to be built with ./configure --openssl-fips)

--force-fips
    Force FIPS-compliant crypto on startup. (Cannot be disabled from script code.) (Same requirements as --enable-fips)

--openssl-config=file
    Load an OpenSSL configuration file on startup. Among other uses, this can be used to enable FIPS-compliant crypto if Node.js is built with ./configure --openssl-fips.

--use-openssl-ca,--use-bundled-ca
    Use OpenSSL's default CA store or use bundled Mozilla CA store as supplied by current Node.js version. The default store is selectable at build-time. Using OpenSSL store allows for external modifications of the store. For most Linux and BSD distributions, this store is maintained by the distribution maintainers and system administrators. OpenSSL CA store location is dependent on configuration of the OpenSSL library but this can be altered at runtime using environment variables. The bundled CA store, as supplied by Node.js, is a snapshot of Mozilla CA store that is fixed at release time. It is identical on all supported platforms. See SSL_CERT_DIR and SSL_CERT_FILE.

--icu-data-dir=file
    Specify ICU data load path. (overrides NODE_ICU_DATA)

--  Indicate the end of node options. Pass the rest of the arguments to the script. If no script filename or eval/print script is supplied prior to this, then the next argument will be used as a script filename.

ENVIRONMENT VARIABLES

NODE_DEBUG=module[,...]
    ','-separated list of core modules that should print debug information.

NODE_PATH=path[:...]
    ':'-separated list of directories prefixed to the module search path.

NODE_DISABLE_COLORS=1
    When set to 1 colors will not be used in the REPL.

NODE_ICU_DATA=file
    Data path for ICU (Intl object) data. Will extend linked-in data when compiled with small-icu support.

NODE_NO_WARNINGS=1
    When set to 1, process warnings are silenced.

NODE_OPTIONS=options...
    options... are interpreted as if they had been specified on the command line before the actual command line (so they can be overriden). Node will exit with an error if an option that is not allowed in the environment is used, such as -p or a script file.

NODE_REPL_HISTORY=file
    Path to the file used to store the persistent REPL history. The default path is ~/.node_repl_history, which is overridden by this variable. Setting the value to an empty string ("" or " ") disables persistent REPL history.

NODE_TTY_UNSAFE_ASYNC=1
    When set to 1, writes to stdout and stderr will be non-blocking and asynchronous when outputting to a TTY on platforms which support async stdio. Setting this will void any guarantee that stdio will not be interleaved or dropped at program exit. Avoid use.

OPENSSL_CONF=file
    Load an OpenSSL configuration file on startup. Among other uses, this can be used to enable FIPS-compliant crypto if Node.js is built with ./configure --openssl-fips. If the --openssl-config command line option is used, the environment variable is ignored. SSL_CERT_DIR=dir If --use-openssl-ca is enabled, this overrides and sets OpenSSL's directory containing trusted certificates.

SSL_CERT_FILE=file
    If --use-openssl-ca is enabled, this overrides and sets OpenSSL's file containing trusted certificates.

NODE_REDIRECT_WARNINGS=file
    Write process warnings to the given file instead of printing to stderr. (equivalent to using the --redirect-warnings=file command-line argument).

BUGS
Bugs are tracked in GitHub Issues:

AUTHORS
Written and maintained by 1000+ contributors:

COPYRIGHT
Copyright Node.js contributors. Node.js is available under the MIT license. Node.js also includes external libraries that are available under a variety of licenses. See for the full license text.

RESOURCES AND DOCUMENTATION
Website: Documentation: GitHub repository & Issue Tracker: Mailing list: IRC (general questions): (unofficial) IRC (Node.js core development):